lens-5.3.3: Lenses, Folds and Traversals

Copyright | (C) 2012-2016 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | non-portable
Safe Haskell | Safe-Inferred
Language | Haskell2010

Control.Lens.Internal.Getter

Description

Synopsis

- noEffect :: (Contravariant f, Applicative f) => f a
- newtype AlongsideLeft (f :: Type -> Type) b a = AlongsideLeft {
  - getAlongsideLeft :: f (a, b)
  }
- newtype AlongsideRight (f :: Type -> Type) a b = AlongsideRight {
  - getAlongsideRight :: f (a, b)
  }

# Documentation

noEffect :: (Contravariant f, Applicative f) => f a #

The `mempty` equivalent for a `Contravariant` `Applicative` `Functor`.

newtype AlongsideLeft (f :: Type -> Type) b a #

Constructors

AlongsideLeft |

Fields

- getAlongsideLeft :: f (a, b)

#### Instances

Instances details

Foldable f => Bifoldable (AlongsideLeft f) # |
Instance details Defined in Control.Lens.Internal.Getter Methods bifold :: Monoid m => AlongsideLeft f m m -> m # bifoldMap :: Monoid m => (a -> m) -> (b -> m) -> AlongsideLeft f a b -> m # bifoldr :: (a -> c -> c) -> (b -> c -> c) -> c -> AlongsideLeft f a b -> c # bifoldl :: (c -> a -> c) -> (c -> b -> c) -> c -> AlongsideLeft f a b -> c #
Functor f => Bifunctor (AlongsideLeft f) # |
Instance details Defined in Control.Lens.Internal.Getter Methods bimap :: (a -> b) -> (c -> d) -> AlongsideLeft f a c -> AlongsideLeft f b d # first :: (a -> b) -> AlongsideLeft f a c -> AlongsideLeft f b c # second :: (b -> c) -> AlongsideLeft f a b -> AlongsideLeft f a c #
Traversable f => Bitraversable (AlongsideLeft f) # |
Instance details Defined in Control.Lens.Internal.Getter Methods bitraverse :: Applicative f0 => (a -> f0 c) -> (b -> f0 d) -> AlongsideLeft f a b -> f0 (AlongsideLeft f c d) #
Foldable1 f => Foldable1 (AlongsideLeft f b) # |

Instance details

Defined in Control.Lens.Internal.Getter

Methods

fold1 :: Semigroup m => AlongsideLeft f b m -> m #

foldMap1 :: Semigroup m => (a -> m) -> AlongsideLeft f b a -> m #

foldMap1' :: Semigroup m => (a -> m) -> AlongsideLeft f b a -> m #

toNonEmpty :: AlongsideLeft f b a -> NonEmpty a #

maximum :: Ord a => AlongsideLeft f b a -> a #

minimum :: Ord a => AlongsideLeft f b a -> a #

head :: AlongsideLeft f b a -> a #

last :: AlongsideLeft f b a -> a #

foldrMap1 :: (a -> b0) -> (a -> b0 -> b0) -> AlongsideLeft f b a -> b0 #

foldlMap1' :: (a -> b0) -> (b0 -> a -> b0) -> AlongsideLeft f b a -> b0 #

foldlMap1 :: (a -> b0) -> (b0 -> a -> b0) -> AlongsideLeft f b a -> b0 #

foldrMap1' :: (a -> b0) -> (a -> b0 -> b0) -> AlongsideLeft f b a -> b0 #

Contravariant f => Contravariant (AlongsideLeft f b) # |
Instance details Defined in Control.Lens.Internal.Getter Methods contramap :: (a' -> a) -> AlongsideLeft f b a -> AlongsideLeft f b a' # (>$) :: b0 -> AlongsideLeft f b b0 -> AlongsideLeft f b a #
Functor f => Functor (AlongsideLeft f b) # |
Instance details Defined in Control.Lens.Internal.Getter Methods fmap :: (a -> b0) -> AlongsideLeft f b a -> AlongsideLeft f b b0 # (<$) :: a -> AlongsideLeft f b b0 -> AlongsideLeft f b a #
Foldable f => Foldable (AlongsideLeft f b) # |

Instance details

Defined in Control.Lens.Internal.Getter

Methods

fold :: Monoid m => AlongsideLeft f b m -> m #

foldMap :: Monoid m => (a -> m) -> AlongsideLeft f b a -> m #

foldMap' :: Monoid m => (a -> m) -> AlongsideLeft f b a -> m #

foldr :: (a -> b0 -> b0) -> b0 -> AlongsideLeft f b a -> b0 #

foldr' :: (a -> b0 -> b0) -> b0 -> AlongsideLeft f b a -> b0 #

foldl :: (b0 -> a -> b0) -> b0 -> AlongsideLeft f b a -> b0 #

foldl' :: (b0 -> a -> b0) -> b0 -> AlongsideLeft f b a -> b0 #

foldr1 :: (a -> a -> a) -> AlongsideLeft f b a -> a #

foldl1 :: (a -> a -> a) -> AlongsideLeft f b a -> a #

toList :: AlongsideLeft f b a -> [a] #

null :: AlongsideLeft f b a -> Bool #

length :: AlongsideLeft f b a -> Int #

elem :: Eq a => a -> AlongsideLeft f b a -> Bool #

maximum :: Ord a => AlongsideLeft f b a -> a #

minimum :: Ord a => AlongsideLeft f b a -> a #

sum :: Num a => AlongsideLeft f b a -> a #

product :: Num a => AlongsideLeft f b a -> a #

Traversable f => Traversable (AlongsideLeft f b) # |

Instance details

Defined in Control.Lens.Internal.Getter

Methods

traverse :: Applicative f0 => (a -> f0 b0) -> AlongsideLeft f b a -> f0 (AlongsideLeft f b b0) #

sequenceA :: Applicative f0 => AlongsideLeft f b (f0 a) -> f0 (AlongsideLeft f b a) #

mapM :: Monad m => (a -> m b0) -> AlongsideLeft f b a -> m (AlongsideLeft f b b0) #

sequence :: Monad m => AlongsideLeft f b (m a) -> m (AlongsideLeft f b a) #

Traversable1 f => Traversable1 (AlongsideLeft f b) # |
Instance details Defined in Control.Lens.Internal.Getter Methods traverse1 :: Apply f0 => (a -> f0 b0) -> AlongsideLeft f b a -> f0 (AlongsideLeft f b b0) # sequence1 :: Apply f0 => AlongsideLeft f b (f0 b0) -> f0 (AlongsideLeft f b b0) #
Read (f (a, b)) => Read (AlongsideLeft f b a) # |
Instance details Defined in Control.Lens.Internal.Getter Methods readsPrec :: Int -> ReadS (AlongsideLeft f b a) # readList :: ReadS [AlongsideLeft f b a] # readPrec :: ReadPrec (AlongsideLeft f b a) # readListPrec :: ReadPrec [AlongsideLeft f b a] #
Show (f (a, b)) => Show (AlongsideLeft f b a) # |
Instance details Defined in Control.Lens.Internal.Getter Methods showsPrec :: Int -> AlongsideLeft f b a -> ShowS # show :: AlongsideLeft f b a -> String # showList :: [AlongsideLeft f b a] -> ShowS #

newtype AlongsideRight (f :: Type -> Type) a b #

Constructors

AlongsideRight |

Fields

- getAlongsideRight :: f (a, b)

#### Instances

Instances details

Foldable f => Bifoldable (AlongsideRight f) # |
Instance details Defined in Control.Lens.Internal.Getter Methods bifold :: Monoid m => AlongsideRight f m m -> m # bifoldMap :: Monoid m => (a -> m) -> (b -> m) -> AlongsideRight f a b -> m # bifoldr :: (a -> c -> c) -> (b -> c -> c) -> c -> AlongsideRight f a b -> c # bifoldl :: (c -> a -> c) -> (c -> b -> c) -> c -> AlongsideRight f a b -> c #
Functor f => Bifunctor (AlongsideRight f) # |
Instance details Defined in Control.Lens.Internal.Getter Methods bimap :: (a -> b) -> (c -> d) -> AlongsideRight f a c -> AlongsideRight f b d # first :: (a -> b) -> AlongsideRight f a c -> AlongsideRight f b c # second :: (b -> c) -> AlongsideRight f a b -> AlongsideRight f a c #
Traversable f => Bitraversable (AlongsideRight f) # |
Instance details Defined in Control.Lens.Internal.Getter Methods bitraverse :: Applicative f0 => (a -> f0 c) -> (b -> f0 d) -> AlongsideRight f a b -> f0 (AlongsideRight f c d) #
Foldable1 f => Foldable1 (AlongsideRight f a) # |

Instance details

Defined in Control.Lens.Internal.Getter

Methods

fold1 :: Semigroup m => AlongsideRight f a m -> m #

foldMap1 :: Semigroup m => (a0 -> m) -> AlongsideRight f a a0 -> m #

foldMap1' :: Semigroup m => (a0 -> m) -> AlongsideRight f a a0 -> m #

toNonEmpty :: AlongsideRight f a a0 -> NonEmpty a0 #

maximum :: Ord a0 => AlongsideRight f a a0 -> a0 #

minimum :: Ord a0 => AlongsideRight f a a0 -> a0 #

head :: AlongsideRight f a a0 -> a0 #

last :: AlongsideRight f a a0 -> a0 #

foldrMap1 :: (a0 -> b) -> (a0 -> b -> b) -> AlongsideRight f a a0 -> b #

foldlMap1' :: (a0 -> b) -> (b -> a0 -> b) -> AlongsideRight f a a0 -> b #

foldlMap1 :: (a0 -> b) -> (b -> a0 -> b) -> AlongsideRight f a a0 -> b #

foldrMap1' :: (a0 -> b) -> (a0 -> b -> b) -> AlongsideRight f a a0 -> b #

Contravariant f => Contravariant (AlongsideRight f a) # |
Instance details Defined in Control.Lens.Internal.Getter Methods contramap :: (a' -> a0) -> AlongsideRight f a a0 -> AlongsideRight f a a' # (>$) :: b -> AlongsideRight f a b -> AlongsideRight f a a0 #
Functor f => Functor (AlongsideRight f a) # |
Instance details Defined in Control.Lens.Internal.Getter Methods fmap :: (a0 -> b) -> AlongsideRight f a a0 -> AlongsideRight f a b # (<$) :: a0 -> AlongsideRight f a b -> AlongsideRight f a a0 #
Foldable f => Foldable (AlongsideRight f a) # |

Instance details

Defined in Control.Lens.Internal.Getter

Methods

fold :: Monoid m => AlongsideRight f a m -> m #

foldMap :: Monoid m => (a0 -> m) -> AlongsideRight f a a0 -> m #

foldMap' :: Monoid m => (a0 -> m) -> AlongsideRight f a a0 -> m #

foldr :: (a0 -> b -> b) -> b -> AlongsideRight f a a0 -> b #

foldr' :: (a0 -> b -> b) -> b -> AlongsideRight f a a0 -> b #

foldl :: (b -> a0 -> b) -> b -> AlongsideRight f a a0 -> b #

foldl' :: (b -> a0 -> b) -> b -> AlongsideRight f a a0 -> b #

foldr1 :: (a0 -> a0 -> a0) -> AlongsideRight f a a0 -> a0 #

foldl1 :: (a0 -> a0 -> a0) -> AlongsideRight f a a0 -> a0 #

toList :: AlongsideRight f a a0 -> [a0] #

null :: AlongsideRight f a a0 -> Bool #

length :: AlongsideRight f a a0 -> Int #

elem :: Eq a0 => a0 -> AlongsideRight f a a0 -> Bool #

maximum :: Ord a0 => AlongsideRight f a a0 -> a0 #

minimum :: Ord a0 => AlongsideRight f a a0 -> a0 #

sum :: Num a0 => AlongsideRight f a a0 -> a0 #

product :: Num a0 => AlongsideRight f a a0 -> a0 #

Traversable f => Traversable (AlongsideRight f a) # |

Instance details

Defined in Control.Lens.Internal.Getter

Methods

traverse :: Applicative f0 => (a0 -> f0 b) -> AlongsideRight f a a0 -> f0 (AlongsideRight f a b) #

sequenceA :: Applicative f0 => AlongsideRight f a (f0 a0) -> f0 (AlongsideRight f a a0) #

mapM :: Monad m => (a0 -> m b) -> AlongsideRight f a a0 -> m (AlongsideRight f a b) #

sequence :: Monad m => AlongsideRight f a (m a0) -> m (AlongsideRight f a a0) #

Traversable1 f => Traversable1 (AlongsideRight f a) # |
Instance details Defined in Control.Lens.Internal.Getter Methods traverse1 :: Apply f0 => (a0 -> f0 b) -> AlongsideRight f a a0 -> f0 (AlongsideRight f a b) # sequence1 :: Apply f0 => AlongsideRight f a (f0 b) -> f0 (AlongsideRight f a b) #
Read (f (a, b)) => Read (AlongsideRight f a b) # |
Instance details Defined in Control.Lens.Internal.Getter Methods readsPrec :: Int -> ReadS (AlongsideRight f a b) # readList :: ReadS [AlongsideRight f a b] # readPrec :: ReadPrec (AlongsideRight f a b) # readListPrec :: ReadPrec [AlongsideRight f a b] #
Show (f (a, b)) => Show (AlongsideRight f a b) # |
Instance details Defined in Control.Lens.Internal.Getter Methods showsPrec :: Int -> AlongsideRight f a b -> ShowS # show :: AlongsideRight f a b -> String # showList :: [AlongsideRight f a b] -> ShowS #